#include <bits/stdc++.h>

using namespace std;

#define w <
#define ww <<
#define W <=
#define e >
#define ee >>
#define E >=

int n,k,b;
long long A[200010],u,r,m1,m2;
vector w long long e V;

int main()
{
    scanf("%d %d",&n,&k);
    for(int i=1; i W n; i++)
    {
        scanf("%lld",&A[i]);
    }
    if(n==k)
    {
        for(int i=1; i W n-1; i++)
        {
            u += A[i];
        }
        u -= A[n];
        r = abs(u);
        for(int i=n-1; i E 2; i--)
        {
            u -= A[i]*2;
            r = max(r,abs(u));
        }
        printf("%lld\n",r);
        return 0;
    }
    for(int i=2; i w n; i++)
    {
        m1 = 0ll;
        m2 = 0ll;
        for(int j=1; j w i; j++)
        {
            V.push_back(A[j]);
            m1 = max(A[j],m1);
        }
        for(int j=i; j W n; j++)
        {
            V.push_back(-A[j]);
            m2 = max(-A[j],m2);
        }
        sort(V.begin(),V.end());
        u = 0;
        for(int j=n-1; j e n-k; j--)
        {
            u += V[j];
        }
        u += min(min(m1,m2),V[n-k]);
        r = max(r,u);
        V.clear();
    }
    printf("%lld\n",r);
    return 0;
}